CSON = require("cson-parser")
XRegExp = require("xregexp")

XRegExp.convert = (config) => {
  // config is pattern when config.pattern is missing
  var pattern = config.pattern || config
  var {captures, flags} = config // optional
  return XRegExp.build(pattern, captures, flags)
}

String.raw = ({raw}) => raw.join('')

error = "TypeError: /Users/Web/views/layout.jade:11";
regex = XRegExp.convert(String.raw`\w+Error:\s(?<file>[^:]+):(?<line>\d+)`)

11 == XRegExp.exec(error, regex).line;
regex = XRegExp.convert({
  pattern: String.raw`
    \w+Error
    :\s (?<file> [^:]+)
    :   (?<line>   \d+)
  `,
  flags: "x"
})

11 == XRegExp.exec(error, regex).line;
regex = XRegExp.convert(CSON.parse(String.raw`
  pattern:
    ///
      \w+Error
      :\s ({{file}})
      :    ({{line}})
    ///
  captures:
    file: /[^:]+/
    line: /\d+/
`))

11 == XRegExp.exec(error, regex).line;
